#!/bin/bash

mkdir -p /tmp/build

# Build 3D engine.
if [ ! -f /tmp/build/libengine.rlib ]; then
	rustc --out-dir /tmp/build -g --crate-name engine --crate-type lib engine/src/lib.rs || exit 1
fi

# Build scripting language (Wren).
if [ ! -f /tmp/build/libwren.a ]; then
	mkdir -p /tmp/build/libwren
	for INPUT in src/3rd-party/wren-0.4.0/optional/*.c src/3rd-party/wren-0.4.0/vm/*.c; do
		FILE=$(basename "$INPUT")
		gcc -g -DDEBUG \
			-I src/3rd-party/wren-0.4.0/include \
			-I src/3rd-party/wren-0.4.0/optional \
			-I src/3rd-party/wren-0.4.0/vm \
			-o "/tmp/build/libwren/$FILE.o" -c \
			"$INPUT" || exit 1
	done
	ar rcs /tmp/build/libwren.a /tmp/build/libwren/*.o || exit 1
fi

rustc --out-dir /tmp/build -g -L /tmp/build -L assets src/main.rs || exit 1
