uniform mat3 clip_matrix;
uniform vec3 clip_translate;
uniform float clip_z_offset;
uniform float clip_z_scale;
uniform vec3 camera_position;
uniform float trail_width;

attribute vec3 position;
attribute vec3 normal;
attribute vec2 texcoord;

varying float vertex_fog;
varying vec2 vertex_texcoord;

void main() {
	vec3 up = normalize(cross(normal, camera_position-position));
	vec3 offset = up*((texcoord.y-0.5)*trail_width);
	vec3 preclip = clip_matrix*(position+offset)+clip_translate;
	gl_Position = vec4(preclip.x, preclip.y, preclip.z*clip_z_scale+clip_z_offset, preclip.z);

	float fog_far = 200.0;
	vertex_fog = pow(min(length(preclip)/fog_far, 1.0), 2.0);
	vertex_texcoord = texcoord;
}
